---
layout: page
title: Samza Enhancement Proposals
---
<!--
   Licensed to the Apache Software Foundation (ASF) under one or more
   contributor license agreements.  See the NOTICE file distributed with
   this work for additional information regarding copyright ownership.
   The ASF licenses this file to You under the Apache License, Version 2.0
   (the "License"); you may not use this file except in compliance with
   the License.  You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
-->

<!-- TODO link to jira when we have an apache jira. -->

When making larger changes to Samza, or working on a [project](/contribute/projects.html), please write a Samza Enhancement Proposal (SEP) on the Samza wiki. The goal of the SEP is to:

1. Define the problem you're trying to solve
2. Propose a solution, and explore alternatives.
3. Instigate discussion on the issue.
4. Archive design documents for future use.

### How to Write a SEP

SEPs are stored on the Samza wiki. To write a SEP, create a new sub page on the wiki with a title formatted as SEP-# (e.g. SEP-24).

There is no set single format for a SEP, but it's common to include:

1. Table of Contents
2. Introduction
3. Definition of problem
4. Possible solutions
5. Opinion on best solution
6. Proposed metrics to add.
7. A link to the [JIRA](https://issues.apache.org/jira/browse/SAMZA).
